#!/usr/bin/python
# _*_ coding:utf-8 _*_
import sys

import time

from config import define_attr
from config import setting_crawer
from mws import Amazon_Finance
import os
from publicfile.customizeClass import MyException
from publicfile.customizeFunction import empty_result


def checkoutPath():
    if not os.path.exists(setting_crawer.GROUP_ID_PATH):
        os.mkdir(setting_crawer.GROUP_ID_PATH)

    if not os.path.exists(setting_crawer.ACCOUNT_PATH):
        raise MyException('你没有亚马逊用户信息哦！快去弄好,放在./config里面,并且命名为amazon_account.csv')


def checkoutGroupIDFile(storename):
    with open(setting_crawer.GROUP_ID_PATH + storename + '.csv', 'w') as check_file:
        check_file.write('\t'.join(setting_crawer.GROUP_ID_CSV_FIELDS)+"\n")

try:
    empty_result()
    checkoutPath()
except Exception,e:
    print e
    sys.exit()

with open(setting_crawer.ACCOUNT_PATH) as account_list:
    account_line = account_list.readline().replace('\n','').split(',')
    account_line = account_list.readline().replace('\n','').split(',')
    '''
        account_line[1] 店铺名
    '''
    while len(account_line) > 1:
        if define_attr.crawer_account and account_line[1] not in define_attr.crawer_account:
            account_line = account_list.readline().replace('\n', '').split(',')
            continue
        elif account_line[1] in define_attr.no_crawer_account:
            account_line = account_list.readline().replace('\n', '').split(',')
            continue
        amazon_api = Amazon_Finance(access_key=account_line[2],
                                    secret_key=account_line[3],
                                    account_id=account_line[4],
                                    mws_auth_token=account_line[6],
                                    region=define_attr.region.get(account_line[5], 'US'),
                                    mkplace_id=account_line[5],
                                    )
        retry_num = 1
        checkoutGroupIDFile(account_line[1])
        with open(setting_crawer.GROUP_ID_PATH + account_line[1] + '.csv','a+') as account_group_id_file:
            while retry_num <= 3:
                try:
                    group_id_dict = amazon_api.list_finace_event_group(define_attr.starttime,define_attr.endtime)
                    group_id_list = group_id_dict.parsed.get('FinancialEventGroupList',{}).get('FinancialEventGroup',[])
                    group_id_save_list = []
                    if isinstance(group_id_list,dict):
                        group_id = group_id_list.get('FinancialEventGroupId', {}).get('value', '')
                        if group_id:
                            group_id_save_list.append(group_id)
                            print('%s---->groupid  :  %s   已经存储成功' % (account_line[1], str(group_id)))
                    else:
                        for group_id_line in group_id_list:
                            group_id = group_id_line.get('FinancialEventGroupId',{}).get('value','')
                            if group_id:
                                group_id_save_list.append(group_id)
                                print('%s---->groupid  :  %s   已经存储成功' % (account_line[1], str(group_id)))

                    account_group_id_file.write("\n".join(group_id_save_list))
                    break
                except Exception,e:
                    print('%s---->访问API异常,正在重试第%d次  :  %s'%(account_line[1], retry_num, str(e)[:100]))
                    retry_num += 1



        account_line = account_list.readline().replace('\n','').split(',')
