#!/usr/bin/env python
# -*- coding:utf-8 -*-
# 开发者：程文先
# 功能：原生数据库操作
# 内容：数据库的增删改查操作的封装,以及一些表的字段的处理

import MySQLdb
from warnings import filterwarnings
filterwarnings('error', category = MySQLdb.Warning)

class MyDB(object):
    db_host = ''
    db_user = ''
    db_password = ''
    db_database = ''

    def __init__(self):
        self.db_host = "192.168.1.251"
        self.db_user = "starpro"
        self.db_password = "x"
        self.db_database = "finance"

    def do_line(self,sql_line):
        db = MySQLdb.connect(self.db_host,self.db_user,self.db_password,self.db_database)
        cursor = db.cursor()
        try:
            cursor.execute(sql_line)
            db.commit()
        except (MySQLdb.Warning,BaseException), w:
            print w
            db.rollback()
        db.close()

    def get_infos(self,sql_line):
        db = MySQLdb.connect(self.db_host,self.db_user,self.db_password,self.db_database)
        cursor = db.cursor()
        data = None
        try:
            cursor.execute(sql_line)
            data = cursor.fetchall()
        except (MySQLdb.Warning,BaseException), w:
            print w

        db.close()
        return data

    def get_finance_amazon_fields(self):
        return 'storename,date,type,orderid,fsku,description,quantity,marketplace,fulfillment,productsales,shippingcredits,giftwrapcredits,promotional_rebates,salestax_collected,sellingfees,fbafees,othertransactionfees,other,total'

    # date,type,orderid,fsku,description,quantity,marketplace,fulfillment,productsales,
    # shippingcredits,giftwrapcredits,promotional_rebates,salestax_collected,sellingfees,fbafees,othertransactionfees
    # other,total,[account]
    def get_finance_amazon_fba_fields(self):
        return 'date,type,orderid,fsku,description,quantity,marketplace,productsales,shippingcredits,giftwrapcredits,promotional_rebates,salestax_collected,sellingfees,fbafees,othertransactionfees,other,total,storename,fulfillment,ordercity,orderstate,orderpostal'