#!/usr/bin/python
# _*_ coding:utf-8 _*_
'''
创建者：程文先
功能：程序运行的配置文件
内容：各种目录路径,表格字段列表
'''

# 结果文件夹
RESULT_PATH = './result/'

# Amazon账户信息,包括token等
ACCOUNT_PATH = './config/amazon_account.csv'

# 财务信息的groupID,由API：list_finace_event_group返回
GROUP_ID_PATH = './result/groupid/'

# 财务信息,由API：list_finace_event返回
EVENTS_PATH = './result/events/'

# 订单信息,由API：get_order返回
ORDER_PATH = './result/orders/'

# 财务信息的groupID,由API：list_finace_event_group返回
XML_GROUP_ID_PATH = './xml_result/groupid/'

# 财务信息,由API：list_finace_event返回
XML_EVENTS_PATH = './xml_result/events/'

# 订单信息,由API：get_order返回
XML_ORDER_PATH = './xml_result/orders/'

# 日志信息,记录访问API过程中的异常数据
API_LOG_PATH = './log/group/'

# 日志信息,记录访问API过程中的异常数据
API_LOG_PATH = './log/order/'

# 日志信息,记录访问API过程中的异常数据
MYSQL_LOG_PATH = './log/mysql/'

# 财务信息的groupID CSV文件的字段列表
GROUP_ID_CSV_FIELDS = [
    'groupid'
]

# 财务信息的events CSV文件的字段列表
EVENTS_CSV_FIELDS = ['datetime', 'settlement', 'type', 'account_id', 'orderID', 'sku', 'description', 'quantity', 'marketplace', 'fulfillment', 'productSales',
         'shippingCredits', 'giftWrapCredits', 'promotionalRebates', 'salesTaxCollected', 'sellingFees', 'fbaFees', 'otherTransactionFees', 'other', 'total', 'acount']

# 订单信息的order CSV文件的字段列表
ORDER_CSV_FIELDS = ['storename','datetime','type','orderID','orderstatus','order_city','order_state','order_postal']

